
#include <module.h>
#include "amxxmodule.h"

void OnLoadLibrary(LibraryForModule* library){}

#ifdef __linux__
		typedef void* (*CCSBotConstructType)(void*);
#else
		typedef void* (_fastcall *CCSBotConstructType)(void*);
#endif

void* vtable = NULL;
int vtable_offset = 0;

FunctionForModule* CallGameEntity = NULL;

bool got = false;

RageHookReturn OnCallGameEntityPre(plid_t*& plid, const char*& entStr,entvars_t*& pev,qboolean& ret)
{
	got = false;

	if(!strcmp("czbot",entStr))
	{
		got = true;
		entStr = "player";
	}

	return RageHookIgnored;
}
RageHookReturn OnCallGameEntityPost(plid_t*& plid, const char*& entStr,entvars_t*& pev,qboolean& ret)
{
	if(got)
	{
		char* object = (char*) Rage->entvar_to_edict(pev)->pvPrivateData;
		*((void**)&object[vtable_offset]) = vtable;
	}
	
	return RageHookIgnored;
}

void OnLoadFunction(FunctionForModule* function)
{
	if(!strcmp(function->get_name(),"CCSBot::CCSBot"))
	{
		vtable_offset = Rage->get_vtable_offset("CBaseEntity");

		if(vtable_offset == -1)
		{
			Rage->add_error("[hambot] Failed to retrieve vtable offset for CBaseEntity");
			return;
		}

		if(!CallGameEntity)
		{
			Rage->add_error("[hambot] CallGameEntity not registered");
			return;
		}

		CCSBotConstructType bot_constructor = (CCSBotConstructType) function->get_managed_address();

		{
			unsigned char* alloc = new unsigned char[12000];
			
			bot_constructor(alloc);	

			vtable = *((void**)&alloc[vtable_offset]);

			delete[] alloc;
		}

		CallGameEntity->add_module_hook((void*)&OnCallGameEntityPre,RageHookPre);
		CallGameEntity->add_module_hook((void*)&OnCallGameEntityPost,RageHookPost);
	}
}

void OnLoadVirtualFunction(VirtualFunctionForModule* virtual_function){}

void OnLoadFunctionIncomplete(FunctionIncompleteForModule* function_incomplete)
{
	if(!strcmp(function_incomplete->get_name(),"CallGameEntity"))
	{
		CallGameEntity = function_incomplete->finish((void*)gpMetaUtilFuncs->pfnCallGameEntity);
	}
}

